<?php
if( !class_exists('QuoteRotator') ) :

class QuoteRotator
{
	var $tableName;
	var $pluginPath;
	
	function QuoteRotator()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$this->tableName = $wpdb->prefix . 'QuoteRotator';
		$this->pluginPath = get_settings('siteurl') . '/wp-content/plugins/quote-rotator/';
		
		$options = get_option('widgetQuoteRotator');
		
		if ( ($wpdb->get_var("SHOW TABLES LIKE '" . $this->tableName . "'") == $this->tableName) && (!$options['version'] || $options['version'] < 2.0) )
		{
			$sql = "ALTER TABLE `" . $this->tableName . "` CHANGE `quote` `quote` TEXT NULL;";
			$wpdb->query($sql);
			$options['version'] = 2.0;
			update_option('widgetQuoteRotator', $options);
			delete_option('widgetizeQuoteRotator');
		}
	}
	
	function createDatabaseTable()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
			
		$options = get_option('widgetQuoteRotator');
		if ( !is_array($options) ){
			$options = array();
			$options['title'] = 'Quote Rotator';
			$options['delay'] = 5;
		}
		
		if( $wpdb->get_var("SHOW TABLES LIKE '" . $this->tableName . "'") != $this->tableName)
		{
			$sql = "CREATE TABLE `" . $this->tableName . "` (`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT PRIMARY KEY, `quote` TEXT NULL);";
			require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
			dbDelta($sql);
			$options['version'] = 2.0;
		}
		
		update_option('widgetQuoteRotator', $options);
		delete_option('widgetizeQuoteRotator');
	}
	
	function deleteDatabaseTable()
	{
		global $wpdb;
		
		$sql = "DROP TABLE IF EXISTS " . $this->tableName . ";";	
		$wpdb->query($sql);
	}
	
	function addHeaderContent()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$options = get_option('widgetQuoteRotator');
		
		$sql = "SELECT * FROM " . $this->tableName;
		$results = $wpdb->get_results($sql);
		
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/prototype.js\" type=\"text/javascript\"></script>\n";
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/scriptaculous.js\" type=\"text/javascript\"></script>\n";
		
		echo "<script type=\"text/javascript\">\n";
		echo "var i=1\n";
		echo "var quotes = new Array();\n";
		echo "\tvar opac=100\n";
		echo "\tvar showFading=1\n";
		echo "\tvar opac=100\n";
		$i=0;
		foreach($results as $result){
			echo "quotes[$i]=\"$result->quote\"\n";
			$i++;
		}
		echo "var num_quotes=$i\n";
		echo "function quotesInit(){\n";
		echo "\tif(num_quotes>0){\n";
		echo "\tdocument.getElementById('quoterotator').style.opacity=0.0\n";
		echo "\tdocument.getElementById('quoterotator').style.filter=\"alpha(opacity=0.0)\"\n";
		echo "\tnew Effect.Appear('quoterotator',{duration:1.5})\n";
		echo "\t\tdocument.getElementById('quoterotator').innerHTML=quotes[0]\n";
		echo "\t}\n";
		echo "\telse{\n";
		echo "\t\tdocument.getElementById('quoterotator').innerHTML=\"No Quotes Found!!!\"\n";
		echo "\t}\n";
		echo "\tif(num_quotes>1){\n";
		echo "\t\tsetInterval(\"quoteRotate()\", " . $options['delay']*1000 . ")\n";
		echo "\t}\n";
		echo "}\n";
		echo "function quoteRotate(){\n";
		echo "\tdocument.getElementById('quoterotator').style.opacity=0.0\n";
		echo "\tdocument.getElementById('quoterotator').style.filter=\"alpha(opacity=0.0)\"\n";
		echo "\tnew Effect.Appear('quoterotator',{duration:1.5})\n";
		echo "\tdocument.getElementById('quoterotator').innerHTML=quotes[i]\n";
		echo "\ti++\n";
		echo "\tif(i==num_quotes){\n";
		echo "\t\ti=0\n";
		echo "\t}\n";
		echo "}\n";
		echo "</script>";
	}
		
	function displayWidget($args)
	{
		extract($args);
		
		$options = get_option('widgetQuoteRotator');
		$title = $options['title'];
		
		echo $before_widget . $before_title . $title . $after_title;
		
		echo "<div id=\"quoterotator\">\n";
		echo "Loading Quotes...\n";
		echo "</div>\n";
		echo "<script type=\"text/javascript\">setTimeout(\"quotesInit()\", 2000)</script>\n";
		
		echo $after_widget;
	}
}

endif;
?>